import es
import cfglib
import popuplib
import usermsg
import playerlib
import gamethread
from odict import odict
import AchievementGroup as AchGroup
import Achievement
from AchievementIO import *

import psyco
psyco.full()

_achievementIO = None
_mainPopup = None

# == ADDON INFO =========================================
info = es.AddonInfo()
info.name        = "Make-Your-Own Achievements"
info.version     = "v3.0.0 RC1"
info.author      = "The Bash"
info.url         = "http://addons.eventscripts.com/addons/view/myo_achievement"
info.basename    = "myo_achievement"
info.description = "Provides an easy way to add your own achievements by EventScripts."
info.cfgpath     = "config.cfg"
# =======================================================

# == CONFIG FILE CONFIGURATION ==========================
config = cfglib.AddonCFG(es.getAddonPath("myo_achievement") + "/" + info.cfgpath)

config.text("*****************************************") 
config.text("    " + info.name + " " + info.version)
config.text("    Configuration File")
config.text("*****************************************")
config.text("")
config.text("*****************************************")
config.text("    Functionality options")
config.text("*****************************************")
 
frontOfMessage        = config.cvar("myoa_front", "[Achievements]", "This is used at the beginning of each message from myo_achievements")
showSayCommands       = config.cvar("myoa_show_commands", 0, "This is used to set if the say commands are shown or not, 0 = Do not show, 1 = Do show")

popupSayCommand       = config.cvar("myoa_popup_command", "!achievements", "This is the say command to bring up the MYOA popups")
popupWidth            = config.cvar("myoa_popup_width", 30, "This is the maximum width in characters for each line in the popup")

showAdverts           = config.cvar("myoa_adverts", 60, "The number of seconds between MYOA adverts, set to 0 if you don't want adverts on")

useSound              = config.cvar("myoa_use_sound", 1, "Change this to 1 if you have sounds to use to indicate that a player has achieved/unachieved/reset an achievement")
soundVolume           = config.cvar("myoa_sound_volume", 0.7, "This is the volume that the sounds will play at, in a range of 0.0 to 1.0")
achieveSound          = config.cvar("myoa_achieve_sound", "myo_achievements/achieve.mp3", "This is the path to the sound that plays when a player achieves an achievement")
unachieveSound        = config.cvar("myoa_unachieve_sound", "myo_achievements/unachieve.mp3", "This is the path to the sound that plays when a player unachieves an achievement")
resetSound            = config.cvar("myoa_reset_sound", "myo_achievements/reset.mp3", "This is the path to the sound that plays when a player resets an achievement")

useWeb                = config.cvar("myoa_use_web", 0, "Change this to 1 if you want the user to view your MYOA website via a say command, keep this set to 0 if you choose to use a local storage method")
webSayCommand         = config.cvar("myoa_web_command", "!achievementsweb", "This is the say command to bring up your MYOA website")
webUrl                = config.cvar("myoa_web_url", "http://www.yourdomain.com", "This is the URL where your MYOA website is based")

debugLevel            = config.cvar("myoa_debug_off", 1, "Change this to 0 if you are having problems and wish to see debug messages from MYOA")

config.text("")
config.text("*****************************************")
config.text("    Storage options")
config.text("*****************************************")

storageMethod         = config.cvar("myoa_storage_method", 1, "Change this to store using different methods, 1 = cPickle, 2 = Sqlite, 3 = MySQL, 4 = MySQL via PHP")
storageOnRoundEnd     = config.cvar("myoa_storage_only_round_end", 0, "Change this to 1 to force MYOA to only do storage actions during round-ends (not applicable if using cPickle)")

pickleAchievements    = config.cvar("myoa_pickle_achievements_name", "database.db", "This is the name of the cPickle file to use for achievements (only required if using cPickle)")
pickleRanks           = config.cvar("myoa_pickle_ranks_name", "playerranks.db", "This is the name of the cPickle file to use for rankings (only required if using cPickle)")
picklePairs           = config.cvar("myoa_pickle_pairs_name", "playerpairs.db", "This is the name of the cPickle file to use for player pairs (only required if using cPickle)")

dbName                = config.cvar("myoa_db_name", "myo_achievement.sqldb", "This is the name of the database to use (Sqlite: filename of database, MySQL: database name, MySQL via PHP: url to database php file, value not required if using cPickle)")

dbHost                = config.cvar("myoa_mysqldb_host", "localhost", "This is the hostname/IP where the MySQL database is located (only required if using MySQL)")
dbUser                = config.cvar("myoa_mysqldb_user", "user", "This is the username for the MySQL database (only required if using MySQL)")
dbPass                = config.cvar("myoa_mysqldb_pass", "password", "This is the password for the MySQL database (only required if using MySQL)")

dbSecretKey           = config.cvar("myoa_php_secretkey", "secret_key", "This is the secret key to confirm valid use of the MySQL database (only required if using MySQL via PHP)")

config.write()
# =======================================================

# == CONSOLE COMMAND REGISTRATION =======================
es.regcmd("myoa_add_group", "myo_achievement/addGroupByConsole", "Command for adding achivement groups by console.")
es.regcmd("myoa_add_achievement", "myo_achievement/addAchievementByConsole", "Command for adding achievements by console.")
es.regcmd("myoa_set_progress_player", "myo_achievement/setProgressPlayerByConsole", "Command for setting progress by console.")
es.regcmd("myoa_step_progress_player", "myo_achievement/stepProgressPlayerByConsole", "Command for stepping progress by console.")
es.regcmd("myoa_step_progress_list", "myo_achievement/stepProgressListByConsole", "Command for stepping progress by console.")
es.regcmd("myoa_step_progress_all", "myo_achievement/stepProgressAllByConsole", "Command for stepping progress by console.")
es.regcmd("myoa_complete_progress_player", "myo_achievement/completeAchievementPlayerByConsole", "Command for completing progress by console.")
es.regcmd("myoa_complete_progress_list", "myo_achievement/completeAchievementListByConsole", "Command for completing progress by console.")
es.regcmd("myoa_complete_progress_all", "myo_achievement/completeAchievementAllByConsole", "Command for completing progress by console.")
es.regcmd("myoa_reset_progress_player", "myo_achievement/resetAchievementPlayerByConsole", "Command for resetting progress by console.")
es.regcmd("myoa_reset_progress_list", "myo_achievement/resetAchievementListByConsole", "Command for resetting progress by console.")
es.regcmd("myoa_reset_progress_all", "myo_achievement/resetAchievementAllByConsole", "Command for resetting progress by console.")
es.regcmd("myoa_get_player_progress", "myo_achievement/getPlayerProgressByConsole", "Command for returning the player progress by console.")
es.regcmd("myoa_is_player_completed", "myo_achievement/isPlayerCompletedByConsole", "Command for returning if the player has completed by console.")
es.regcmd("myoa_set_name_pair", "myo_achievement/setPlayerNamePairByConsole", "Command for setting name pair by console.")
es.regcmd("myoa_set_rank", "myo_achievement/setPlayerRankByConsole", "Command for setting player rank by console.")
# =======================================================

# == PRIVATE GLOBAL VARIABLES ===========================
_achievementGroups = odict()
_mainPopup = None
_advertPos = 0
# =======================================================

# == ES EVENTS ==========================================
def load():
    """
    Occurs on load of the script
    """
    global _achievementIO
    global _mainPopup
    
    #Set myo_achievement version info
    es.set("myo_achievement_version",info.version)
    es.makepublic("myo_achievement_version")
    
    #Load events
    es.loadevents("declare", es.getAddonPath("myo_achievement") + "/achievementevents.res")
    
    config.execute()

    #Register saycommands
    if not showSayCommands == "1":
        if not es.exists("saycommand", popupSayCommand):
            es.regsaycmd(popupSayCommand, "myo_achievement/showMainPopup", "Shows the MYOA main popup.")
        
        if not es.exists("saycommand", webSayCommand):
            es.regsaycmd(webSayCommand, "myo_achievement/showWeb", "Shows your MYOA webpage.")
            
    onlyRoundEnd = (storageOnRoundEnd == "1")
    
    #Create the appropriate storage method
    if storageMethod == "1":
        _achievementIO = AchievementIOPickle(pickleAchievements, pickleRanks, picklePairs)
    elif storageMethod == "2":
        _achievementIO = AchievementIOSqlite(dbName, int(onlyRoundEnd) == 1)
    elif storageMethod == "3":
        _achievementIO = AchievementIOMySQL(dbName, dbHost, dbUser, dbPass, int(onlyRoundEnd) == 1)
    elif storageMethod == "4":
        _achievementIO = AchievementIOMySQLPHP(dbName, dbSecretKey, int(onlyRoundEnd) == 1)
    
    if not _achievementIO == None:
        _achievementIO.debugLevel = int(debugLevel)

    #Create the main popup    
    _mainPopup = popuplib.easymenu('myoa_menu', None, showMainPopupCallback)
    _mainPopup.settitle("MYOA Main Menu")
    _mainPopup.addoption("player", "Player Progress")
    _mainPopup.addoption("achievements", "Achievements")
        
    #Add sounds to stringtables if using
    if useSound == "1":
        es.stringtable("downloadables", "sound/%s" % (achieveSound))
        es.stringtable("downloadables", "sound/%s" % (unachieveSound))
        es.stringtable("downloadables", "sound/%s" % (resetSound))        
             
    Achievement.achievementIO = _achievementIO
    
    if int(showAdverts) > 0:
        gamethread.delayedname(int(showAdverts), "MYOA_Adverts", showAdvert)

def player_activate(ev):
    """
    Occurs when a player is activated. Calls the onPlayerConnect method of the AIO
    """
    global _achievementIO
    if not _achievementIO is None:
        _achievementIO.onPlayerConnect(Achievement.getUniqueSteam(ev["userid"]))
        
def player_disconnect(ev):
    """
    Occurs when a player disconnects. Calls the onPlayerDisconnect method of the AIO
    """
    global _achievementIO
    if not _achievementIO is None:
        _achievementIO.onPlayerDisconnect(Achievement.getUniqueSteam(ev["userid"]))
    
    valToLook = Achievement.uniqueSteams[ev["userid"]]
    toDelete = []
    for val in Achievement.uniqueSteams.keys():
        if Achievement.uniqueSteams[val] == valToLook:
            toDelete.append(val)
    
    for deleteKey in toDelete:
        del Achievement.uniqueSteams[deleteKey]

def round_end(ev):
    """
    Occurs at the end of a round (CS:S only). Calls the onRoundEnd method of the AIO, and saves
    """
    global _achievementIO
    if not _achievementIO is None:
        if not isinstance(_achievementIO, AchievementIOPickle):
            _achievementIO.save()
            _achievementIO.onRoundEnd()
                   
def es_map_start(ev):
    """
    Occurs at the beginning of a map. Calls save() on AIO, reloads events and stringtables
    """
    global _achievementIO
    es.loadevents(es.getAddonPath("myo_achievement") + "/achievementevents.res")
    if not _achievementIO is None:
        _achievementIO.save()
        
    if useSound == "1":
        es.stringtable("downloadables", "sound/%s" % (achieveSound))
        es.stringtable("downloadables", "sound/%s" % (unachieveSound))
        es.stringtable("downloadables", "sound/%s" % (resetSound))

def player_changename(ev):
    """
    Occurs when a player changes their name. Updates the player name/steam pairs
    """
    global _achievementIO
    if not _achievementIO is None:
        _achievementIO.setPlayerName(Achievement.getUniqueSteam(ev["userid"]), ev["newname"])

def player_say(ev):
    """
    Occurs when a player says something. Does the same as saycommands, but shows the text instead
    """
    if showSayCommands == "1":
        if ev["text"] == popupSayCommand:
            getAchievementGroups(ev["userid"])
        elif ev["text"] == webSayCommand and useWeb == "1":
            getOtherPlayerAchievementGroups(None, ev["userid"])
            
def unload():
    """
    Occurs when the script is unloaded
    """
    global _achievementIO
    
    gamethread.cancelDelayed("MYOA_Adverts")
    
    #Tidy up main popup
    _mainPopup.delete()
    
    #Save & close AIO
    if not _achievementIO is None:
        _achievementIO.save()
        _achievementIO.close()
# =======================================================

# == ACHIEVEMENT EVENTS =================================
def achievement_achieved(ev):
    """
    A raised event that occurs when an achievement has been achieved.
    event_vars:
        achievementgroupid (string): The Achievement Group ID of the Achievement achieved
        achievementid      (string): The Achievement ID of the Achievement achieved
        playerid           (string): The player ID/userid of the player that achieved the Achievement 
    """
    global _achievementIO
    steamID = Achievement.getUniqueSteam(ev["playerid"])
    #Increase achievement count in AIO    
    if not _achievementIO is None:
        achievementCount = _achievementIO.getPlayerAchievementCount(steamID)
        achievementCount = achievementCount + 1
        _achievementIO.setPlayerAchievementCount(steamID, achievementCount)
        _achievementIO.onPlayerAchievementEvent(steamID, ev["achievementgroupid"], ev["achievementid"], "achieved")
        
    #If using sounds, play sound    
    if useSound == "1":
        es.emitsound("player", ev["playerid"], achieveSound, float(soundVolume), 0.0)

    #Message & Log achievement
    achievementName = _achievementGroups[ev["achievementgroupid"]][ev["achievementid"]].name
    es.msg("#multi", "#lightgreen%s#default %s" % (frontOfMessage, _getMessage(achievementName, "achieved by", ev["playerid"])))
    es.log("[MYOA] \"%s<%s>\"[%s, %s] ACHIEVED" % (Achievement.getPlayerName(steamID), steamID, ev["achievementgroupid"], ev["achievementid"]))
    
def achievement_unachieved(ev):
    """
    A raised event that occurs when an achievement has been unachieved.
    event_vars:
        achievementgroupid (string): The Achievement Group ID of the Achievement unachieved
        achievementid      (string): The Achievement ID of the Achievement unachieved
        playerid           (string): The player ID/userid of the player that unachieved the Achievement 
    """
    global _achievementIO
    steamID = Achievement.getUniqueSteam(ev["playerid"])
    #Decrease achievement count in AIO
    if not _achievementIO is None:
        achievementCount = _achievementIO.getPlayerAchievementCount(steamID)
        if achievementCount > 0:
            achievementCount = achievementCount - 1
            _achievementIO.setPlayerAchievementCount(steamID, achievementCount)
        _achievementIO.onPlayerAchievementEvent(steamID, ev["achievementgroupid"], ev["achievementid"], "un-achieved")
    
    #If using sounds, play sound    
    if useSound == "1":
        es.emitsound("player", ev["playerid"], unachieveSound, float(soundVolume), 0.0)
    
    #Message & Log achievement
    achievementName = _achievementGroups[ev["achievementgroupid"]][ev["achievementid"]].name
    es.msg("#multi", "#lightgreen%s#default %s" % (frontOfMessage, _getMessage(achievementName, "un-achieved by", ev["playerid"])))
    es.log("[MYOA] \"%s<%s>\"[%s, %s] UNACHIEVED" % (Achievement.getPlayerName(steamID), steamID, ev["achievementgroupid"], ev["achievementid"]))
    
def achievement_reset(ev):
    """
    A raised event that occurs when an achievement has been reset.
    event_vars:
        achievementgroupid (string): The Achievement Group ID of the Achievement reset
        achievementid      (string): The Achievement ID of the Achievement reset
        playerid           (string): The player ID/userid of the player that the Achievement was reset on
    """
    global _achievementIO
    steamID = Achievement.getUniqueSteam(ev["playerid"])
    #Decrease achievement count in AIO
    if not _achievementIO is None:
        achievementCount = _achievementIO.getPlayerAchievementCount(steamID)
        if achievementCount > 0:
            achievementCount = achievementCount - 1
            _achievementIO.setPlayerAchievementCount(steamID, achievementCount)
        _achievementIO.onPlayerAchievementEvent(steamID, ev["achievementgroupid"], ev["achievementid"], "reset")
    
    #If using sounds, play sound    
    if useSound == "1":
        es.emitsound("player", ev["playerid"], resetSound, float(soundVolume), 0.0)

    #Message & Log achievement                    
    achievementName = _achievementGroups[ev["achievementgroupid"]][ev["achievementid"]].name
    es.msg("#multi", "#lightgreen%s#default %s" % (frontOfMessage, _getMessage(achievementName, "reset for", ev["playerid"])))
    es.log("[MYOA] \"%s<%s>\"[%s, %s] RESET" % (Achievement.getPlayerName(steamID), steamID, groupID, achievementID))
# =======================================================

# == INTERFACE METHODS ==================================
def AddAchievementGroup(newID, newName, newDescription):
    """
    PUBLIC INTERFACE
    Adds an achievement group to the dictionary
    """
    global _achievementGroups
    if not newID in _achievementGroups.keys():
        _achievementGroups[newID] = AchGroup.AchievementGroup(newID, newName, newDescription)
        if not _achievementIO is None:
            _achievementIO.setAchievementGroupProperties(newID, newName, newDescription)
    return _achievementGroups[newID]

def AchievementGroup(newID, newName, newDescription):
    """
    PUBLIC INTERFACE
    Adds an achievement group to the dictionary
    """
    return AddAchievementGroup(newID, newName, newDescription)
# =======================================================

# == HELPER METHODS =====================================
def _getMessage(achievementName, action, playerID):
    """
    A method to return an es.msg(..)-friendly string given a particular achievement name, action, and player
    """
    playerName = Achievement.getPlayerName(playerID)
    return ("The#green %s Achievement#default has been %s #green%s#default!" % (achievementName, action, playerName))

def _getPopupAdjustedText(text):
    """
    A method to return a popup-friendly string confined to the designated popupWidth
    """
    wordList = text.split(" ")
    finalText = ""
    length = 0
    for word in wordList:
        length = length + len(word) + 1
        if length > int(popupWidth):
            finalText = finalText + "\n"
            length = len(word) + 1
        finalText = finalText + word + " "
    return finalText      
# =======================================================

# == SAY COMMANDS =======================================
def showMainPopup(userid = None):
    """
    Shows the main menu popup
    """
    global _mainPopup
    if userid == None:
        userid = es.getcmduserid()
        
    if es.getargc() > 1:
        name = ""
        for i in range(1, es.getargc()):
            if not name == "":
                name = name + " "
            name = name + es.getargv(i)
        showPlayerList(userid, name)
    else:
        _mainPopup.send(userid)
    
def showWeb():
    """
    Shows the website if using web
    """
    if int(useWeb) != 0:
        usermsg.motd(es.getcmduserid(), 2, "MYOA Achievement Progress", webUrl)
# =======================================================

# == ADVERT METHOD =====================================
def showAdvert():
    """
    Shows an advert to all players
    """
    if int(useWeb) != 0:
        global _advertPos
        _advertPos = (_advertPos + 1) % 2
        if _advertPos == 0:
            es.msg("#multi", "#lightgreen%s#default To bring up a popup to access information about achievements, say #green%s#default." % (frontOfMessage, str(popupSayCommand)))
        else:
            es.msg("#multi", "#lightgreen%s#default To bring up a website to access information about achievements, say #green%s#default." % (frontOfMessage, str(webSayCommand)))
        
    else:
        es.msg("#multi", "#lightgreen%s#default To bring up a popup to access information about achievements, say #green%s#default." % (frontOfMessage, str(popupSayCommand)))
    
    gamethread.delayedname(int(showAdverts), "MYOA_Adverts", showAdvert)
# =======================================================

# == POPUP METHODS ======================================
def showMainPopupCallback(userid, choice, popupname):
    """
    Callback to main menu popup
    """
    if choice == "player":
        showPlayerList(userid)
    elif choice == "achievements":
        showAchievementGroups(userid)
    
def showPlayerList(userid, checkString = None):
    """
    Shows a player list popup
    """
    playerListPopup = popuplib.easymenu("myoa_playerlist_%s" % userid, None, None)
    playerListPopup.menuselect = showPlayerListCallback
    playerListPopup.settitle("Pick a player")
    playerList = playerlib.getPlayerList("#all")
    for ply in playerList:
        name = Achievement.getPlayerName(ply.userid)
        if checkString == None or checkString in name:
            playerListPopup.addoption(Achievement.getUniqueSteam(ply.userid), name)
    playerListPopup.send(userid)

def showPlayerListCallback(userid, choice, popupname):
    """
    Callback to player list popup
    """
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    if str(choice) == "10":
        showMainPopup(userid)
    elif "STEAM" in str(choice) or "BOT" in str(choice):
        showPlayer(userid, choice)

def showPlayer(userid, targetid):
    """
    Shows a popup about a chosen player
    """
    global _achievementIO
    
    playerPopup = popuplib.easymenu("myoa_player_%s" % userid, None, None)
    playerPopup.menuselect = showPlayerCallback
    playerPopup.settitle(Achievement.getPlayerName(targetid))
    if not _achievementIO == None:
        playerPopup.setdescription("Achievement Count: %d" % _achievementIO.getPlayerAchievementCount(targetid))
    
    playerPopup.addoption((targetid, "complete"), "Show Complete Achievements")
    playerPopup.addoption((targetid, "incomplete"), "Show Incomplete Achievements")
    playerPopup.send(userid)

def showPlayerCallback(userid, choice, popupname):
    """
    Callback to player popup
    """
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    if type(choice) is not tuple and str(choice) == "10":
        showPlayerList(userid)
    elif type(choice) is tuple:
        if choice[1] == "complete":
            showCompleteAchievements(userid, choice[0])
        elif choice[1] == "incomplete":
            showIncompleteAchievements(userid, choice[0])

def showCompleteAchievements(userid, targetid):
    """
    Shows a popup of a list of achievements achieved by a chosen player 
    """
    global _achievementGroups
    
    achievementsPopup = popuplib.easymenu("myoa_complete_%s" % userid, None, None)
    achievementsPopup.menuselect = showCompleteAchievementsCallback
    achievementsPopup.settitle(Achievement.getPlayerName(targetid))
    achievementsPopup.setdescription("Complete Achievements")
    for group in _achievementGroups.values():
        for achievement in group.achievements.values():
            if achievement.isPlayerCompleted(targetid):
                achievementsPopup.addoption((group.id, achievement.id, targetid), achievement.name)
    achievementsPopup.send(userid)

def showCompleteAchievementsCallback(userid, choice, popupname):
    """
    Callback to complete achievements popup
    """
    global _achievementGroups
    
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    if type(choice) is not tuple and str(choice) == "10":
        showPlayerList(userid)
    elif type(choice) is tuple:
        showAchievement(userid, _achievementGroups[choice[0]][choice[1]], choice[2])

def showIncompleteAchievements(userid, targetid):
    """
    Shows a popup of a list of achievements not currently achieved by a chosen player 
    """
    global _achievementGroups
    
    achievementsPopup = popuplib.easymenu("myoa_incomplete_%s" % userid, None, None)
    achievementsPopup.menuselect = showIncompleteAchievementsCallback
    achievementsPopup.settitle(Achievement.getPlayerName(targetid))
    achievementsPopup.setdescription("Incomplete Achievements")
    for group in _achievementGroups.values():
        for achievement in group.achievements.values():
            if not achievement.isPlayerCompleted(targetid):
                achievementsPopup.addoption((group.id, achievement.id, targetid), "%s (%d/%d)" % (achievement.name, achievement.getPlayerProgress(targetid), achievement.totalprogress))
    achievementsPopup.send(userid)
    
def showIncompleteAchievementsCallback(userid, choice, popupname):
    """
    Callback to incomplete achievements popup
    """
    global _achievementGroups

    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    if type(choice) is not tuple and str(choice) == "10":
        showPlayerList(userid)
    elif type(choice) is tuple:
        showAchievement(userid, _achievementGroups[choice[0]][choice[1]], choice[2])

def showAchievementGroups(userid):
    """
    Shows a popup of a list of the currently active achievement groups
    """
    global _achievementGroups
    
    groupsPopup = popuplib.easymenu("myoa_groups_%s" % userid, None, None)
    groupsPopup.menuselect = showAchievementGroupsCallback
    groupsPopup.settitle("Pick an Achievement Group")
    for group in _achievementGroups.values():
        groupsPopup.addoption(group, group.name)
    groupsPopup.send(userid)

def showAchievementGroupsCallback(userid, choice, popupname):
    """
    Callback to achievement group list popup
    """
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    if not isinstance(choice, AchGroup.AchievementGroup) and str(choice) == "10":
        showMainPopup(userid)
    elif isinstance(choice, AchGroup.AchievementGroup):
        showAchievementGroup(userid, choice)
        
def showAchievementGroup(userid, group):
    """
    Shows a popup detailing a chosen achievement group
    """
    groupPopup = popuplib.easymenu("myoa_group_%s" % userid, None, None)
    groupPopup.menuselect = showAchievementGroupCallback
    groupPopup.settitle(group.name)
    groupPopup.setdescription(_getPopupAdjustedText(group.description))
    for achievement in group.achievements.values():
        groupPopup.addoption(achievement, achievement.name)
    groupPopup.send(userid)

def showAchievementGroupCallback(userid, choice, popupname):
    """
    Callback to achievement group popup
    """
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    if not isinstance(choice, Achievement.Achievement) and str(choice) == "10":
        showAchievementGroups(userid)
    elif isinstance(choice, Achievement.Achievement):
        showAchievement(userid, choice)
    
def showAchievement(userid, achievement, targetid = None):
    """
    Shows a popup detailing a chosen achievement
    """
    achievementPopup = None
    if not targetid == None:
        achievementPopup = popuplib.create("myoa_achievement_%s_%s" % (userid, targetid))
    else:
        achievementPopup = popuplib.create("myoa_achievement_%s_%s" % (userid, achievement.parentid))
    
    achievementPopup.addline(achievement.name)
    achievementPopup.addline(" ")
    achievementPopup.addline(_getPopupAdjustedText(achievement.description))
    achievementPopup.menuselect = showAchievementCallbackA
    progString = ""
    if not targetid == None:
        achievementPopup.menuselect = showAchievementCallbackB
        progString = "%d/" % achievement.getPlayerProgress(targetid)
    achievementPopup.addline("Progress: %s%d" % (progString, achievement.totalprogress))
    achievementPopup.send(userid)

def showAchievementCallbackA(userid, choice, popupname):
    """
    Callback (A) to achievement popup (popup reached via achievement group popup)
    """
    global _achievementGroups
    
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    groupid = popupname.replace("myoa_achievement_%s_" % userid, "")
    showAchievementGroup(userid, _achievementGroups[groupid])

def showAchievementCallbackB(userid, choice, popupname):
    """
    Callback (B) to achievement popup (popup reached via player popup)
    """
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    targetid = popupname.replace("myoa_achievement_%s_" % userid, "")
    showPlayer(userid, targetid)
# =======================================================

# == CONSOLE COMMANDS ===================================
def addGroupByConsole():
    """
    Adds an achievement group
    """
    if es.getargc() == 4:
        AddAchievementGroup(es.getargv(1), es.getargv(2), es.getargv(3))
    else:
        _showSyntaxErrorMessage("myoa_add_group", "myoa_add_group groupid groupname groupdescription")

def addAchievementByConsole():
    """
    Adds an achievement
    """
    global _achievementGroups
    if es.getargc() == 5:
        _achievementGroups[es.getargv(1)][es.getargv(2)] = (es.getargv(3), es.getargv(4))
    elif es.getargc() == 6:
        _achievementGroups[es.getargv(1)][es.getargv(2)] = (es.getargv(3), es.getargv(4), int(es.getargv(5)))
    else:
        _showSyntaxErrorMessage("myoa_add_achievement", "myoa_add_achievement groupid achievementid achievementname achievementdescription [totalprogress = 1]")

def setProgressPlayerByConsole():
    """
    Sets a player's progress of a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 5:
        _achievementGroups[es.getargv(1)][es.getargv(2)].setProgressForPlayer(es.getargv(3), int(es.getargv(4)))
    elif es.getargc() == 6 and str(es.getargv[5]) == "1":
        _achievementGroups[es.getargv(1)][es.getargv(2)].setProgressForPlayer(es.getargv(3), int(es.getargv(4)), True)    
    else:
        _showSyntaxErrorMessage("myoa_set_progress_player", "myoa_step_progress_player groupid achievementid playerid amount")

def stepProgressPlayerByConsole():
    """
    Steps a player's progress of a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].stepProgressForPlayer(es.getargv(3))    
    elif es.getargc() == 5:
        _achievementGroups[es.getargv(1)][es.getargv(2)].stepProgressForPlayer(es.getargv(3), int(es.getargv(4)))
    else:
        _showSyntaxErrorMessage("myoa_step_progress_player", "myoa_step_progress_player groupid achievementid playerid [stepamount = 1]")

def stepProgressListByConsole():
    """
    Steps a list of players' progresses of a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].stepProgressForList(es.getargv(3))    
    elif es.getargc() == 5:
        _achievementGroups[es.getargv(1)][es.getargv(2)].stepProgressForList(es.getargv(3), es.getargv(4))
    else:
        _showSyntaxErrorMessage("myoa_step_progress_list", "myoa_step_progress_list groupid achievementid listfilter [stepamount = 1]")
        
def stepProgressAllByConsole():
    """
    Steps all players' progresses of a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 3:
        _achievementGroups[es.getargv(1)][es.getargv(2)].stepProgressForAllActive()    
    elif es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].stepProgressForAllActive(es.getargv(3))
    else:
        _showSyntaxErrorMessage("myoa_step_progress_all", "myoa_step_progress_all groupid achievementid [stepamount = 1]")
        
def completeProgressPlayerByConsole():
    """
    Sets a player's progress to complete for a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].completeProgressForPlayer(es.getargv(3))    
    elif es.getargc() == 5:
        _achievementGroups[es.getargv(1)][es.getargv(2)].completeProgressForPlayer(es.getargv(3), es.getargv(4))
    else:
        _showSyntaxErrorMessage("myoa_complete_progress_player", "myoa_complete_progress_player groupid achievementid playerid")

def completeProgressListByConsole():
    """
    Sets a list of players' progresses to complete for a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].completeProgressForList(es.getargv(3))    
    elif es.getargc() == 5:
        _achievementGroups[es.getargv(1)][es.getargv(2)].completeProgressForList(es.getargv(3), es.getargv(4))
    else:
        _showSyntaxErrorMessage("myoa_complete_progress_list", "myoa_complete_progress_list groupid achievementid listfilter")
        
def completeProgressAllByConsole():
    """
    Sets all players' progresses to complete for a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 3:
        _achievementGroups[es.getargv(1)][es.getargv(2)].completeProgressForAllActive()    
    elif es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].completeProgressForAllActive(es.getargv(3))
    else:
        _showSyntaxErrorMessage("myoa_complete_progress_all", "myoa_complete_progress_all groupid achievementid")

def resetProgressPlayerByConsole():
    """
    Resets a player's progress of a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].resetProgressForPlayer(es.getargv(3))    
    elif es.getargc() == 5:
        _achievementGroups[es.getargv(1)][es.getargv(2)].resetProgressForPlayer(es.getargv(3), es.getargv(4))
    else:
        _showSyntaxErrorMessage("myoa_reset_progress_player", "myoa_reset_progress_player groupid achievementid playerid")

def resetProgressListByConsole():
    """
    Resets a list of players' progresses of a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].resetProgressForList(es.getargv(3))    
    elif es.getargc() == 5:
        _achievementGroups[es.getargv(1)][es.getargv(2)].resetProgressForList(es.getargv(3), es.getargv(4))
    else:
        _showSyntaxErrorMessage("myoa_reset_progress_list", "myoa_reset_progress_list groupid achievementid listfilter")
        
def resetProgressAllByConsole():
    """
    Resets all players' progresses of a particular achievement
    """
    global _achievementGroups
    if es.getargc() == 3:
        _achievementGroups[es.getargv(1)][es.getargv(2)].resetProgressForAllActive()    
    elif es.getargc() == 4:
        _achievementGroups[es.getargv(1)][es.getargv(2)].resetProgressForAllActive(es.getargv(3))
    else:
        _showSyntaxErrorMessage("myoa_reset_progress_all", "myoa_reset_progress_all groupid achievementid")

def getPlayerProgressByConsole():
    """
    Returns the progress of a particular player of a particular event through a server cvar
    """
    global _achievementGroups
    if es.getargc() == 4:
        es.set("myoa_player_progress", _achievementGroups[es.getargv(1)][es.getargv(2)].getPlayerProgress(es.getargv(3)))    
    else:
        _showSyntaxErrorMessage("myoa_get_player_progress", "myoa_get_player_progress groupid achievementid playerid")

def isPlayerCompletedByConsole():
    """
    Returns a 1 or 0 through a server cvar, depending if a player has completed a particular achievement or not
    """
    global _achievementGroups
    if es.getargc() == 4:
        if _achievementGroups[es.getargv(1)][es.getargv(2)].isPlayerCompleted(es.getargv(3)) == True:
            es.set("myoa_player_complete", 1)
        else:
            es.set("myoa_player_complete", 0)
    else:
        _showSyntaxErrorMessage("myoa_is_player_completed", "myoa_is_player_completed groupid achievementid playerid")

def setPlayerNamePairByConsole():
    """
    Sets a player's name pair by console
    """
    global _achievementIO
    if es.getargc() == 3:
        _achievementIO.setPlayerName(es.getargv(1), es.getargv(2), True)
    else:
        _showSyntaxErrorMessage("myoa_set_name_pair", "myoa_set_name_pair steamid name")

def setPlayerRankByConsole():
    """
    Sets a player's rank by console
    """
    global _achievementIO
    if es.getargc() == 3:
        _achievementIO.setPlayerAchievementCount(es.getargv(1), int(es.getargv(2)), True)
    else:
        _showSyntaxErrorMessage("myoa_set_rank", "myoa_set_rank steamid achievementcount")

def _showSyntaxErrorMessage(command, requiredArgs):
    es.dbgmsg(int(debugLevel), "[MYOA] Error: Invalid syntax for %s (wrong number of arguments).\nRequired arguments: %s" % (command, requiredArgs))
# =======================================================